Attribute VB_Name = "clip1"

Option Explicit



'Funciones Api
Public Declare Function IsClipboardFormatAvailable Lib "user32" (ByVal _
                        wFormat As Long) As Long
Public Declare Function OpenClipboard Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetClipboardData Lib "user32" (ByVal wFormat As _
                        Long) As Long
Public Declare Function DragQueryFile Lib "shell32.dll" Alias "DragQueryFileA" _
                        (ByVal hDrop As Long, ByVal UINT As Long, ByVal lpStr _
                        As String, ByVal ch As Long) As Long
Public Declare Function CloseClipboard Lib "user32" () As Long


Public Const CF_HDROP = 15
Public Const MAX_PATH As Long = 260

'Funcin que obtiene la lista de archivos del clipboard
Public Function Obtener_archivos(handle As Long, arrayArchivo() As String) As Long
Dim hDrop As Long
Dim nArchivo As Long
Dim nameArchivo As String
Dim i As Long
Dim ret As Long

ReDim arrayArchivo(0)

If IsClipboardFormatAvailable(CF_HDROP) Then

  Call OpenClipboard(0&)
  
  hDrop = GetClipboardData(CF_HDROP)

  nArchivo = DragQueryFile(hDrop, -1&, "", 0)

  ReDim arrayArchivo(nArchivo)

  For i = 0 To nArchivo - 1
    nameArchivo = Space(MAX_PATH)
    ret = DragQueryFile(hDrop, i, nameArchivo, Len(nameArchivo))
    
    arrayArchivo(i + 1) = Left(nameArchivo, ret)
  Next
End If

Obtener_archivos = nArchivo
'Cierra el Clipboard
CloseClipboard

End Function

